diff --git a/src/usr/lib/kernel/install.d/50-mkinitcpio-fallback.install b/src/usr/lib/kernel/install.d/50-mkinitcpio-fallback.install
index 5e95b1d..775945a 100755
--- a/src/usr/lib/kernel/install.d/50-mkinitcpio-fallback.install
+++ b/src/usr/lib/kernel/install.d/50-mkinitcpio-fallback.install
@@ -1,12 +1,51 @@
-#!/bin/sh
+#!/usr/bin/env bash
+# SPDX-License-Identifier: GPL-2.0-only
-case $1 in
- add)
- mkinitcpio -S autodetect -k "$2" -g "$3"/initrd-fallback
+COMMAND="${1:?}"
+KERNEL_VERSION="${2:?}"
+# shellcheck disable=SC2034
+ENTRY_DIR_ABS="$3"
+KERNEL_IMAGE="$4"
+
+[[ "${KERNEL_INSTALL_INITRD_GENERATOR:-mkinitcpio}" == 'mkinitcpio' ]] || exit 0
+
+[[ "$COMMAND" == "add" ]] || exit 0
+
+GENERATOR_CMD=(mkinitcpio -k "$KERNEL_VERSION")
+BLS_ARGS=(-g "$KERNEL_INSTALL_STAGING_AREA/initrd-fallback")
+
+case "$KERNEL_INSTALL_LAYOUT" in
+ uki)
+ #TODO change default to ukify once they have a suitable install script
+ if [[ "${KERNEL_INSTALL_UKI_GENERATOR:-mkinitcpio}" != 'mkinitcpio' ]]; then
+ GENERATOR_CMD+=("${BLS_ARGS[@]}")
+ else
+ GENERATOR_CMD+=(--kernelimage "$KERNEL_IMAGE")
+
+ # autodetecting microcode images by known location
+ # They're from GRUB_EARLY_INITRD_LINUX_STOCK in https://git.savannah.gnu.org/cgit/grub.git/tree/util/grub-mkconfig.in.
+ ucode_names=("intel-ucode.img" "amd-ucode.img" "intel-uc.img" "amd-uc.img" "early_ucode.cpio" "microcode.cpio")
+ for ucode_name in "${ucode_names[@]}"; do
+ for dir in "$KERNEL_INSTALL_BOOT_ROOT" "/boot"; do
+ if [[ -f "${dir}/${ucode_name}" ]]; then
+ (( KERNEL_INSTALL_VERBOSE )) && printf "+ Found microcode image %s\n" "$ucode_name"
+ GENERATOR_CMD+=(--microcode "${dir}/$ucode_name")
+ fi
+ done
+ done
+
+ GENERATOR_CMD+=(-U "$KERNEL_INSTALL_STAGING_AREA/uki.efi" )
+ fi
;;
- remove)
- rm -f -- "$3"/initrd-fallback
+ bls)
+ GENERATOR_CMD+=("${BLS_ARGS[@]}")
+ ;;
+ *)
+ exit 0
;;
esac
+(( KERNEL_INSTALL_VERBOSE )) && printf "+ %s\n" "${GENERATOR_CMD[*]}"
+"${GENERATOR_CMD[@]}"
+
# vim: set ft=sh ts=4 sw=4 et:
diff --git a/src/usr/lib/kernel/install.d/90-ucode-loaderentry-fallback.install b/src/usr/lib/kernel/install.d/90-ucode-loaderentry-fallback.install
index 3927e9d..50b807c 100755
--- a/src/usr/lib/kernel/install.d/90-ucode-loaderentry-fallback.install
+++ b/src/usr/lib/kernel/install.d/90-ucode-loaderentry-fallback.install
@@ -1,124 +1,173 @@
-#!/usr/bin/env bash
+#!/bin/sh
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
+# SPDX-License-Identifier: LGPL-2.1-or-later
+#
+# This file is part of systemd.
+#
+# systemd is free software; you can redistribute it and/or modify it
+# under the terms of the GNU Lesser General Public License as published by
+# the Free Software Foundation; either version 2.1 of the License, or
+# (at your option) any later version.
+#
+# systemd is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with systemd; If not, see .
-COMMAND="$1"
-KERNEL_VERSION="$2"
-ENTRY_DIR_ABS="$3"
+set -e
+
+COMMAND="${1:?}"
+KERNEL_VERSION="${2:?}"
+ENTRY_DIR_ABS="${3:?}"
KERNEL_IMAGE="$4"
-INITRD_OPTIONS_START="5"
+INITRD_OPTIONS_SHIFT=4
-if ! [[ $KERNEL_INSTALL_MACHINE_ID ]]; then
- exit 0
+[ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0
+
+MACHINE_ID="$KERNEL_INSTALL_MACHINE_ID"
+ENTRY_TOKEN="$KERNEL_INSTALL_ENTRY_TOKEN"
+BOOT_ROOT="$KERNEL_INSTALL_BOOT_ROOT"
+
+[ -n "$BOOT_MNT" ] || BOOT_MNT="$(stat -c %m "$BOOT_ROOT")"
+if [ "$BOOT_MNT" = '/' ]; then
+ ENTRY_DIR="$ENTRY_DIR_ABS"
+else
+ ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}"
fi
-if ! [[ -d "$ENTRY_DIR_ABS" ]]; then
- exit 0
-fi
+KERNEL_DEST="$ENTRY_DIR_ABS/linux"
+KERNEL_ENTRY="$ENTRY_DIR/linux"
+LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback.conf"
-MACHINE_ID=$KERNEL_INSTALL_MACHINE_ID
+case "$COMMAND" in
+ remove)
+ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
+ echo "Removing ${LOADER_ENTRY%.conf}*.conf"
+ exec rm -f \
+ "$LOADER_ENTRY" \
+ "${LOADER_ENTRY%.conf}"*".conf"
+ ;;
+ add)
+ ;;
+ *)
+ exit 0
+ ;;
+esac
-BOOT_ROOT=${ENTRY_DIR_ABS%/$MACHINE_ID/$KERNEL_VERSION}
-BOOT_MNT=$(stat -c %m $BOOT_ROOT)
-ENTRY_DIR=${ENTRY_DIR_ABS#$BOOT_MNT}
-
-if [[ $COMMAND == remove ]]; then
- rm -f "$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION-fallback.conf"
- rm -f "$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION-fallback+"*".conf"
- exit 0
-fi
-
-if ! [[ $COMMAND == add ]]; then
- exit 1
-fi
-
-if ! [[ $KERNEL_IMAGE ]]; then
- exit 1
-fi
-
-if [[ -f /etc/os-release ]]; then
+if [ -f /etc/os-release ]; then
+ # shellcheck source=/dev/null
. /etc/os-release
-elif [[ -f /usr/lib/os-release ]]; then
+elif [ -f /usr/lib/os-release ]; then
+ # shellcheck source=/dev/null
. /usr/lib/os-release
fi
-if ! [[ $PRETTY_NAME ]]; then
- PRETTY_NAME="Linux $KERNEL_VERSION"
-fi
+[ -n "$PRETTY_NAME" ] || PRETTY_NAME="Linux $KERNEL_VERSION"
-if [[ -f /etc/kernel/cmdline ]]; then
- read -r -d '' -a BOOT_OPTIONS < /etc/kernel/cmdline
-elif [[ -f /usr/lib/kernel/cmdline ]]; then
- read -r -d '' -a BOOT_OPTIONS < /usr/lib/kernel/cmdline
+SORT_KEY="$IMAGE_ID"
+[ -z "$SORT_KEY" ] && SORT_KEY="$ID-$KERNEL_VERSION-fallback"
+
+if [ -n "$KERNEL_INSTALL_CONF_ROOT" ]; then
+ if [ -f "$KERNEL_INSTALL_CONF_ROOT/cmdline" ]; then
+ BOOT_OPTIONS="$(tr -s "$IFS" ' ' <"$KERNEL_INSTALL_CONF_ROOT/cmdline")"
+ fi
+elif [ -f /etc/kernel/cmdline ]; then
+ BOOT_OPTIONS="$(tr -s "$IFS" ' ' &2
+BOOT_OPTIONS="${BOOT_OPTIONS% }"
+
+# If the boot entries are named after the machine ID, then suffix the kernel
+# command line with the machine ID we use, so that the machine ID remains
+# stable, even during factory reset, in the initrd (where the system's machine
+# ID is not directly accessible yet), and if the root file system is volatile.
+if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ] && ! echo "$BOOT_OPTIONS" | grep -q "systemd.machine_id="; then
+ BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID"
+fi
+
+TRIES_FILE="${KERNEL_INSTALL_CONF_ROOT:-/etc/kernel}/tries"
+
+if [ -f "$TRIES_FILE" ]; then
+ read -r TRIES <"$TRIES_FILE"
+ if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then
+ echo "$TRIES_FILE does not contain an integer." >&2
exit 1
fi
- LOADER_ENTRY="$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION-fallback+$TRIES.conf"
-else
- LOADER_ENTRY="$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION-fallback.conf"
+ LOADER_ENTRY="${LOADER_ENTRY%.conf}+$TRIES.conf"
fi
-cp "$KERNEL_IMAGE" "$ENTRY_DIR_ABS/linux" &&
- chown root:root "$ENTRY_DIR_ABS/linux" &&
- chmod 0644 "$ENTRY_DIR_ABS/linux" || {
- echo "Could not copy '$KERNEL_IMAGE to '$ENTRY_DIR_ABS/linux'." >&2
+if ! [ -d "$ENTRY_DIR_ABS" ]; then
+ echo "Error: entry directory '$ENTRY_DIR_ABS' does not exist" >&2
+ exit 1
+fi
+
+install -m 0644 "$KERNEL_IMAGE" "$KERNEL_DEST" || {
+ echo "Error: could not copy '$KERNEL_IMAGE' to '$KERNEL_DEST'." >&2
exit 1
}
+chown root:root "$KERNEL_DEST" || :
-INITRD_OPTIONS=( "/boot/amd-ucode.img" "/boot/intel-ucode.img" "initrd-fallback" )
+shift "$INITRD_OPTIONS_SHIFT"
-for initrd in "${INITRD_OPTIONS[@]}"; do
- if [[ -f "${initrd}" ]]; then
- initrd_basename="$(basename ${initrd})"
- [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
- echo "Installing $ENTRY_DIR_ABS/${initrd_basename}"
- cp "${initrd}" "$ENTRY_DIR_ABS/${initrd_basename}" &&
- chown root:root "$ENTRY_DIR_ABS/${initrd_basename}" &&
- chmod 0644 "$ENTRY_DIR_ABS/${initrd_basename}" || {
- echo "Could not copy '${initrd}' to '$ENTRY_DIR_ABS/${initrd_basename}'." >&2
- exit 1
- }
- fi
+# Identify any needed microcode
+UCODE=$(for x in "/boot/*-ucode.img"; do echo $x; done)
+
+# All files listed as arguments, and staged files starting with "initrd" are installed as initrds.
+for initrd in "$@" "${KERNEL_INSTALL_STAGING_AREA}"/initrd-fallback $UCODE; do
+ [ -f "$initrd" ] || {
+ # [ "$initrd" = "${KERNEL_INSTALL_STAGING_AREA}/initrd*" ] && continue
+ echo "Error: initrd ${initrd} not a file." >&2
+ exit 1
+ }
+
+ initrd_basename="${initrd##*/}"
+ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename"
+ install -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || {
+ echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2
+ exit 1
+ }
+ chown root:root "$ENTRY_DIR_ABS/$initrd_basename" || :
done
-# If no initrd option is supplied, fall back to "initrd" which is
-# the name used by dracut when generating it in its kernel-install hook
-[[ ${#INITRD_OPTIONS[@]} == 0 ]] && INITRD_OPTIONS=( initrd-fallback )
-
mkdir -p "${LOADER_ENTRY%/*}" || {
- echo "Could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
+ echo "Error: could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
exit 1
}
-[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
- echo "Creating $LOADER_ENTRY"
+[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY"
{
+ echo "# Boot Loader Specification type#1 entry"
+ echo "# File created by $0 (systemd 253.5-1-arch)"
echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION-fallback"
- echo "machine-id $MACHINE_ID"
- echo "options ${BOOT_OPTIONS[*]}"
- echo "linux $ENTRY_DIR/linux"
- for initrd in "${INITRD_OPTIONS[@]}"; do
- [[ -f $ENTRY_DIR_ABS/$(basename ${initrd}) ]] && \
- echo "initrd $ENTRY_DIR/$(basename ${initrd})"
+ if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then
+ # See similar logic above for the systemd.machine_id= kernel command line option
+ echo "machine-id $MACHINE_ID"
+ fi
+ [ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY"
+ echo "options $BOOT_OPTIONS"
+ echo "linux $KERNEL_ENTRY"
+
+ have_initrd=
+ for initrd in "${@}" $UCODE "${KERNEL_INSTALL_STAGING_AREA}"/initrd-fallback; do
+ [ -f "$initrd" ] || continue
+ echo "initrd $ENTRY_DIR/${initrd##*/}"
+ have_initrd=yes
done
+
+ # Try "initrd", generated by dracut in its kernel-install hook, if no initrds were supplied
+ [ -z "$have_initrd" ] && [ -f "$ENTRY_DIR_ABS/initrd" ] && echo "initrd $ENTRY_DIR/initrd"
:
-} > "$LOADER_ENTRY" || {
- echo "Could not create loader entry '$LOADER_ENTRY'." >&2
+} >"$LOADER_ENTRY" || {
+ echo "Error: could not create loader entry '$LOADER_ENTRY'." >&2
exit 1
}
exit 0
diff --git a/src/usr/lib/kernel/install.d/90-ucode-loaderentry.install b/src/usr/lib/kernel/install.d/90-ucode-loaderentry.install
index 354084d..5e46f0a 100755
--- a/src/usr/lib/kernel/install.d/90-ucode-loaderentry.install
+++ b/src/usr/lib/kernel/install.d/90-ucode-loaderentry.install
@@ -1,124 +1,173 @@
-#!/usr/bin/env bash
+#!/bin/sh
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
+# SPDX-License-Identifier: LGPL-2.1-or-later
+#
+# This file is part of systemd.
+#
+# systemd is free software; you can redistribute it and/or modify it
+# under the terms of the GNU Lesser General Public License as published by
+# the Free Software Foundation; either version 2.1 of the License, or
+# (at your option) any later version.
+#
+# systemd is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with systemd; If not, see .
-COMMAND="$1"
-KERNEL_VERSION="$2"
-ENTRY_DIR_ABS="$3"
+set -e
+
+COMMAND="${1:?}"
+KERNEL_VERSION="${2:?}"
+ENTRY_DIR_ABS="${3:?}"
KERNEL_IMAGE="$4"
-INITRD_OPTIONS_START="5"
+INITRD_OPTIONS_SHIFT=4
-if ! [[ $KERNEL_INSTALL_MACHINE_ID ]]; then
- exit 0
+[ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0
+
+MACHINE_ID="$KERNEL_INSTALL_MACHINE_ID"
+ENTRY_TOKEN="$KERNEL_INSTALL_ENTRY_TOKEN"
+BOOT_ROOT="$KERNEL_INSTALL_BOOT_ROOT"
+
+[ -n "$BOOT_MNT" ] || BOOT_MNT="$(stat -c %m "$BOOT_ROOT")"
+if [ "$BOOT_MNT" = '/' ]; then
+ ENTRY_DIR="$ENTRY_DIR_ABS"
+else
+ ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}"
fi
-if ! [[ -d "$ENTRY_DIR_ABS" ]]; then
- exit 0
-fi
+KERNEL_DEST="$ENTRY_DIR_ABS/linux"
+KERNEL_ENTRY="$ENTRY_DIR/linux"
+LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION.conf"
-MACHINE_ID=$KERNEL_INSTALL_MACHINE_ID
+case "$COMMAND" in
+ remove)
+ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
+ echo "Removing ${LOADER_ENTRY%.conf}*.conf"
+ exec rm -f \
+ "$LOADER_ENTRY" \
+ "${LOADER_ENTRY%.conf}"*".conf"
+ ;;
+ add)
+ ;;
+ *)
+ exit 0
+ ;;
+esac
-BOOT_ROOT=${ENTRY_DIR_ABS%/$MACHINE_ID/$KERNEL_VERSION}
-BOOT_MNT=$(stat -c %m $BOOT_ROOT)
-ENTRY_DIR=${ENTRY_DIR_ABS#$BOOT_MNT}
-
-if [[ $COMMAND == remove ]]; then
- rm -f "$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION.conf"
- rm -f "$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION+"*".conf"
- exit 0
-fi
-
-if ! [[ $COMMAND == add ]]; then
- exit 1
-fi
-
-if ! [[ $KERNEL_IMAGE ]]; then
- exit 1
-fi
-
-if [[ -f /etc/os-release ]]; then
+if [ -f /etc/os-release ]; then
+ # shellcheck source=/dev/null
. /etc/os-release
-elif [[ -f /usr/lib/os-release ]]; then
+elif [ -f /usr/lib/os-release ]; then
+ # shellcheck source=/dev/null
. /usr/lib/os-release
fi
-if ! [[ $PRETTY_NAME ]]; then
- PRETTY_NAME="Linux $KERNEL_VERSION"
-fi
+[ -n "$PRETTY_NAME" ] || PRETTY_NAME="Linux $KERNEL_VERSION"
-if [[ -f /etc/kernel/cmdline ]]; then
- read -r -d '' -a BOOT_OPTIONS < /etc/kernel/cmdline
-elif [[ -f /usr/lib/kernel/cmdline ]]; then
- read -r -d '' -a BOOT_OPTIONS < /usr/lib/kernel/cmdline
+SORT_KEY="$IMAGE_ID"
+[ -z "$SORT_KEY" ] && SORT_KEY="$ID-$KERNEL_VERSION"
+
+if [ -n "$KERNEL_INSTALL_CONF_ROOT" ]; then
+ if [ -f "$KERNEL_INSTALL_CONF_ROOT/cmdline" ]; then
+ BOOT_OPTIONS="$(tr -s "$IFS" ' ' <"$KERNEL_INSTALL_CONF_ROOT/cmdline")"
+ fi
+elif [ -f /etc/kernel/cmdline ]; then
+ BOOT_OPTIONS="$(tr -s "$IFS" ' ' &2
+BOOT_OPTIONS="${BOOT_OPTIONS% }"
+
+# If the boot entries are named after the machine ID, then suffix the kernel
+# command line with the machine ID we use, so that the machine ID remains
+# stable, even during factory reset, in the initrd (where the system's machine
+# ID is not directly accessible yet), and if the root file system is volatile.
+if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ] && ! echo "$BOOT_OPTIONS" | grep -q "systemd.machine_id="; then
+ BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID"
+fi
+
+TRIES_FILE="${KERNEL_INSTALL_CONF_ROOT:-/etc/kernel}/tries"
+
+if [ -f "$TRIES_FILE" ]; then
+ read -r TRIES <"$TRIES_FILE"
+ if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then
+ echo "$TRIES_FILE does not contain an integer." >&2
exit 1
fi
- LOADER_ENTRY="$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION+$TRIES.conf"
-else
- LOADER_ENTRY="$BOOT_ROOT/loader/entries/$MACHINE_ID-$KERNEL_VERSION.conf"
+ LOADER_ENTRY="${LOADER_ENTRY%.conf}+$TRIES.conf"
fi
-cp "$KERNEL_IMAGE" "$ENTRY_DIR_ABS/linux" &&
- chown root:root "$ENTRY_DIR_ABS/linux" &&
- chmod 0644 "$ENTRY_DIR_ABS/linux" || {
- echo "Could not copy '$KERNEL_IMAGE to '$ENTRY_DIR_ABS/linux'." >&2
+if ! [ -d "$ENTRY_DIR_ABS" ]; then
+ echo "Error: entry directory '$ENTRY_DIR_ABS' does not exist" >&2
+ exit 1
+fi
+
+install -m 0644 "$KERNEL_IMAGE" "$KERNEL_DEST" || {
+ echo "Error: could not copy '$KERNEL_IMAGE' to '$KERNEL_DEST'." >&2
exit 1
}
+chown root:root "$KERNEL_DEST" || :
-INITRD_OPTIONS=( "/boot/amd-ucode.img" "/boot/intel-ucode.img" "initrd" )
+shift "$INITRD_OPTIONS_SHIFT"
-for initrd in "${INITRD_OPTIONS[@]}"; do
- if [[ -f "${initrd}" ]]; then
- initrd_basename="$(basename ${initrd})"
- [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
- echo "Installing $ENTRY_DIR_ABS/${initrd_basename}"
- cp "${initrd}" "$ENTRY_DIR_ABS/${initrd_basename}" &&
- chown root:root "$ENTRY_DIR_ABS/${initrd_basename}" &&
- chmod 0644 "$ENTRY_DIR_ABS/${initrd_basename}" || {
- echo "Could not copy '${initrd}' to '$ENTRY_DIR_ABS/${initrd_basename}'." >&2
- exit 1
- }
- fi
+# Identify any needed microcode
+UCODE=$(for x in "/boot/*-ucode.img"; do echo $x; done)
+
+# All files listed as arguments, and staged files starting with "initrd" are installed as initrds.
+for initrd in "$@" "${KERNEL_INSTALL_STAGING_AREA}"/initrd $UCODE; do
+ [ -f "$initrd" ] || {
+ # [ "$initrd" = "${KERNEL_INSTALL_STAGING_AREA}/initrd*" ] && continue
+ echo "Error: initrd ${initrd} not a file." >&2
+ exit 1
+ }
+
+ initrd_basename="${initrd##*/}"
+ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename"
+ install -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || {
+ echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2
+ exit 1
+ }
+ chown root:root "$ENTRY_DIR_ABS/$initrd_basename" || :
done
-# If no initrd option is supplied, fall back to "initrd" which is
-# the name used by dracut when generating it in its kernel-install hook
-[[ ${#INITRD_OPTIONS[@]} == 0 ]] && INITRD_OPTIONS=( initrd )
-
mkdir -p "${LOADER_ENTRY%/*}" || {
- echo "Could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
+ echo "Error: could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
exit 1
}
-[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
- echo "Creating $LOADER_ENTRY"
+[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY"
{
+ echo "# Boot Loader Specification type#1 entry"
+ echo "# File created by $0 (systemd 253.5-1-arch)"
echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION"
- echo "machine-id $MACHINE_ID"
- echo "options ${BOOT_OPTIONS[*]}"
- echo "linux $ENTRY_DIR/linux"
- for initrd in "${INITRD_OPTIONS[@]}"; do
- [[ -f $ENTRY_DIR_ABS/$(basename ${initrd}) ]] && \
- echo "initrd $ENTRY_DIR/$(basename ${initrd})"
+ if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then
+ # See similar logic above for the systemd.machine_id= kernel command line option
+ echo "machine-id $MACHINE_ID"
+ fi
+ [ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY"
+ echo "options $BOOT_OPTIONS"
+ echo "linux $KERNEL_ENTRY"
+
+ have_initrd=
+ for initrd in "${@}" $UCODE "${KERNEL_INSTALL_STAGING_AREA}"/initrd; do
+ [ -f "$initrd" ] || continue
+ echo "initrd $ENTRY_DIR/${initrd##*/}"
+ have_initrd=yes
done
+
+ # Try "initrd", generated by dracut in its kernel-install hook, if no initrds were supplied
+ [ -z "$have_initrd" ] && [ -f "$ENTRY_DIR_ABS/initrd" ] && echo "initrd $ENTRY_DIR/initrd"
:
-} > "$LOADER_ENTRY" || {
- echo "Could not create loader entry '$LOADER_ENTRY'." >&2
+} >"$LOADER_ENTRY" || {
+ echo "Error: could not create loader entry '$LOADER_ENTRY'." >&2
exit 1
}
exit 0